local addonName, vars = ...				
local L = vars.L				
Profession_RP = vars				
local addon = Profession_RP
local addonsls = "/PrRP"				
local settings
-- 6
local defaults = {				
	enabled = true,			
	playfrequency = 5,			
	sound = true,			
	say = true,			
	pet = true,
	list = true,
	defrag = false,			
}				
				
local pet_n = {				
	[1] = "BattlePet-0-00000486CF51",			
	[2] = "BattlePet-0-00000486CE3C",			
}

local deb_tex = {
	[1] = "This is the ",
	[2] = "SF do ",
	[3] = "pet ",
	[4] = "sou ",
	[5] = "say ",
}
-- 27
local soundfiles = {				
	[1] = {
		DW_Do_not_Swear	= {p=1, t=5},		
		DW_Earth_Death_Scheduled	= {p=10, t=5},		
		DW_Exterminate	= {p=1, t=5},		
		DW_Must_Survive	= {p=1, t=5},		
		DW_Owner_of_Blue_Box	= {p=1, t=5},		
		DW_TARDIS	= {p=1, t=5},		
		DW_Upgrading_is_compulsory	= {p=1, t=5},		
		DW_Weakest_Link	= {p=1, t=5},		
	},
	[2] = {				
		WEF_F_Agree	= {p=1, t=1},		
		WEF_F_Disagree	= {p=1, t=1},		
		WEF_F_Follow	= {p=1, t=1},		
		WEF_F_Greet	= {p=1, t=1},		
		WEF_F_Heal	= {p=1, t=1},		
		WEF_F_Help	= {p=1, t=1},		
		WEF_F_Laugh	= {p=1, t=1},		
		WEF_F_Stop	= {p=1, t=1},		
		WEF_F_Thanks	= {p=1, t=1},		
	},
	[3] = {				
		HEF_F_Agree	= {p=1, t=1},		
		HEF_F_Disagree	= {p=1, t=1},		
		HEF_F_Follow	= {p=1, t=1},		
		HEF_F_Greet	= {p=1, t=1},		
		HEF_F_Heal	= {p=1, t=1},		
		HEF_F_Help	= {p=1, t=1},		
		HEF_F_Laugh	= {p=1, t=1},		
		HEF_F_Stop	= {p=1, t=1},		
		HEF_F_Thanks	= {p=1, t=1},		
	},
}				
-- 51
local lootitems = {				
	[119813] = true, 	-- Furry Caged Beast		
	[119810] = true, 	-- Meaty Caged Beast		
	[119814] = true, 	-- Leathery Caged Beast		
	[119815] = true, 	-- Caged Mighty Wolf		
	[119817] = true, 	-- Caged Mighty Riverbeast		
	[119819] = true, 	-- Caged Mighty Clefthoof
	[2589]   = true,	-- linen-cloth
	[2592]   = true,	-- wool-cloth
	[4306]   = true,	-- silk-cloth
	[4338]   = true,	-- mageweave-cloth
	[14047]  = true,	-- runecloth
	[21877]  = true,	-- netherweave-cloth
	[33470]  = true,	-- frostweave-cloth
	[72988]  = true,	-- windwool-cloth
}				
-- 67
-- chat funtions
function addon:chatMsg(msg) 				
	addon:chatMsg2(addonName..": "..msg)
end				

function addon:chatMsg1(set,msg)		
	addon:chatMsg2(deb_tex[1] .. deb_tex[set] .. msg)
end

function addon:chatMsg2(msg) 				
	DEFAULT_CHAT_FRAME:AddMessage(msg)
end
-- 80(13)
local skinning = GetSpellInfo(8613)
local find_herbs = GetSpellInfo(2368)
local find_mine = GetSpellInfo(2575)
-- 108(20)
function addon:doWork()				
	if not settings or not settings.enabled then return end			
	local now = GetTime()			
	local pause = settings.playfrequency			
	if now < (addon.nextplay or 0) then return end			

 	local pet_gu, pet_f = addon:findpet()

	if settings.pet then
		if not(C_PetJournal.GetSummonedPetGUID()==pet_gu) then
			addon:pet_call(pet_f)
		end
		pet_c = pet_n[pet_f]
	else
		pet_c = pet_gu
	end
	if settings.sound then
		addon:soundplay(pet_f,pause)
	end			
	if settings.say then			
		addon:petsay(pet_c)
	end			
	addon.nextplay = now + pause			
end				
-- 131(23)
function addon:findpet()
	local pet_gu, pet_f
	if C_PetJournal.GetSummonedPetGUID() then 
		pet_gu=C_PetJournal.GetSummonedPetGUID()
	else
		pet_gu=0
	end
	if pet_gu == pet_n[1] then			
		pet_f = 1		
	else			
		pet_f = 2		
	end
	return pet_gu, pet_f
end
-- 146(15)
function addon:soundplay(pet_f,pause)
local soundtable = {}				
local soundsum = 0
local Y_t = 0
if not settings.list then Y_t = 3 else Y_t = 2 end
for name, data in pairs(soundfiles[Y_t]) do
		local soundname = ("Interface\\AddOns\\"..addonName.."\\sound\\"..name..".mp3")
		table.insert(soundtable, {	-- [i]
			soundname, data.p, data.t
			})	
		soundsum = soundsum + data.p
end
	local roll = math.random(soundsum)
		for i,e in ipairs(soundtable) do	
			local f,p,t = unpack(e)
			roll = roll - p
			if roll <= 0 then	
				PlaySoundFile(f, "Master")
				pause = math.max(pause, t)
				break
			end	
		end
end
-- 166(20)
function addon:petsay(pet_f)
	if pet_f == 0 then return end
	local msg = settings.msg or "Give me your skin!"
	local _, petName, _, _, _, _, _, petRace  = C_PetJournal.GetPetInfoByPetID(pet_f)
	if not petName then petName = petRace end
	SendChatMessage("hears " .. petName .. " say " .. "'" .. msg .. "'", "EMOTE");
end
-- 173(7)
function addon:pet_call(pet_f)			
	C_PetJournal.SummonPetByGUID(pet_n[pet_f])			
end				
-- 178(50)
function addon:Loot_Call(msg)				
		local itemstr = LOOT_ITEM_PUSHED_SELF:gsub("%%s","%(.*%)") -- for Skinning
		local itemstr2 = LOOT_ITEM_SELF:gsub("%%s","%(.*%)") -- for tailery
		local message = msg or ""
		local link = message:match(itemstr)
		local link2 = message:match(itemstr2) --
		local hold
		if (link) then hold = link else hold = link2 end
		local id = hold and tonumber(hold:match("\124Hitem:(%d+):"))
		if id and lootitems[id] then		
			addon:doWork()
		end
end				
-- 192(14)
local function frame_OnEvent(self,event,...)				
	if event == "ADDON_LOADED" and select(1,...) == addonName then			
		if not Profession_RPSettings then		
			Profession_RPSettings = {} 	
		end		
		settings = Profession_RPSettings		
		for k,v in pairs(defaults) do		
			if settings[k] == nil then	
				settings[k] = v
			end	
		end		
 elseif event == "UNIT_SPELLCAST_START" then				
		local unitID, spell, rank, lineID, spellID = ...
		if unitID == "player" then
			if spell == skinning or spell == find_herbs or spell == find_mine then
				addon:doWork()
			end
		end		
elseif event == "CHAT_MSG_LOOT" then
		local arg1 = ...
		addon:Loot_Call(arg1)
--elseif event == "CHAT_MSG_WHISPER" then
--		addon:doWork(1)
	end			
end				
-- (23)
function addon:SlashHandler(msg)		
	local cmd = msg:lower()	
	if cmd == "on" then	
		settings.enabled = true
		addon:chatMsg("Enabled.")
	elseif cmd == "off" then	
		settings.enabled = false
		addon:chatMsg("Disabled.")
	elseif cmd == "sound" or cmd == "say" or cmd == "pet" or cmd == "list" or cmd == "defrag" then	
		settings[cmd] = not settings[cmd]
		addon:chatMsg(cmd.." "..(settings[cmd] and "enabled." or "disabled."))
	else	
		addon:chatMsg("Usage: "..addonsls.." [ on | off | say | sound | pet | list ]")
	end	
end		
-- (16)
local frame = CreateFrame("Button", addonName.."HiddenFrame", UIParent)				
frame:SetScript("OnEvent", frame_OnEvent)				
frame:RegisterEvent("ADDON_LOADED")				
frame:RegisterEvent("UNIT_SPELLCAST_START")				
frame:RegisterEvent("CHAT_MSG_LOOT")
--frame:RegisterEvent("CHAT_MSG_WHISPER");
-- (7)
-- slash cmd function
	hash_SlashCmdList[addonsls] = nil			
	SLASH_Profession_RP1 = addonsls			
	SlashCmdList[addonName] = function(msg)			
		addon:SlashHandler(msg)
	end